
/*
 * This is a freeware program. If you use this code, you must leave this
 * comment intact. Please let me know of any bugs or possible enhancements.
 * 
 * Location:  http://tanmaykm.webjump.com/download/ditchIE.zip
 * E-Mail:    tanmaykm@hotmail.com
 * Version:   1.0
 * Date:      28th Dec 1998
 */


#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <windows.h>
#include <conio.h>

#define TYPE_NONE   0
#define TYPE_ROOT   1
#define TYPE_FOLDER 2
#define TYPE_LINK   3
#define U1  "output from '%s' mode can be %s bookmark file.\n"

struct URL_NODE
{
    int             iType;
    char            *szName;
    char            *szLink;
    struct URL_NODE *sibling;
    struct URL_NODE *child;
};


static struct URL_NODE * getNewNode();
static void createList(char *startPath, struct URL_NODE *list, int iFileType);
static void saveList(FILE *fpSaveFile, struct URL_NODE *list);
static void freeList(struct URL_NODE *list);
static void appendPath(char *szPath1, char *szPath2, char *szNewPath);
static void pu();

int main(int argc, char **argv)
{
    struct URL_NODE     *list;
    char                szFullPath[1024], szSaveFile[256];
    char                *favFolder, *userId, cNoOptMode;
    FILE                *fpSaveInto;

    favFolder=getenv("USERPROFILE");
    userId = getenv("USERNAME");

    if (argc < 2)
    {
        printf("Usage: ditchIE [favorites folder] [append|new]\n");
        printf(U1, "append", "pasted to the end of current");
        printf(U1, "new", "replaced as a");
        if (favFolder)
        {
            printf("\nYour favorites folder is: %s\\Favorites\n", favFolder);
            printf("Create a new bookmark file for you? (Y/N) ");
            cNoOptMode = getche();
        }
        if ( ('y'!=cNoOptMode) && ('Y'!=cNoOptMode) )
        {
            return 0;
        }
        else
        {
            appendPath(favFolder, "Favorites\\*", szFullPath);
        }
    }
    else
    {
        appendPath(argv[1], "*", szFullPath);
    }

    list = getNewNode();
    list->iType = TYPE_ROOT;

    createList(szFullPath, list, TYPE_FOLDER);
    createList(szFullPath, list, TYPE_LINK);

    sprintf(szSaveFile, "%s.htm", userId ? userId : "Tan");
    fpSaveInto = (fpSaveInto = fopen(szSaveFile, "w")) ? fpSaveInto : stdout;
    
    if ((argc>2) && !stricmp(argv[2], "new"))
    {
        fprintf(fpSaveInto, "<TITLE>");pu();printf("'s Bookmarks</TITLE>\n<H1>");pu();printf("'s Bookmarks</H1>");
    }

    saveList(fpSaveInto, list);
    freeList(list);

    if (fpSaveInto != stdout)
    {
        fclose(fpSaveInto);
    }
    return 0;
}

static void pu()
{
    static int i=0, j=84;

    switch(i++)
    {
        case 0: printf("%c", j); j+=13; pu(); break;
        case 1: printf("%c", j); j+=13; pu(); break;
        case 2: printf("%c", j); j-=26; i-=3; break;
    }
}

static struct URL_NODE * getNewNode()
{
    return calloc(1, sizeof(struct URL_NODE));
}

static void appendPath(char *szPath1, char *szPath2, char *szNewPath)
{
    char szStrippedPath1[1024];

    strcpy(szStrippedPath1, szPath1);
    if ('*' == szStrippedPath1[strlen(szStrippedPath1)-1])
    {
        szStrippedPath1[strlen(szPath1)-1] = '\0';
    }

    sprintf(szNewPath, ('\\'==szStrippedPath1[strlen(szStrippedPath1)-1])?"%s%s":"%s\\%s", szStrippedPath1, szPath2);
}

static void createList(char *startPath, struct URL_NODE *list, int iFileType)
{
    HANDLE          FindHandle;
    WIN32_FIND_DATA FindFileData;
    char            subDirPath[1024];
    struct URL_NODE *thisNode, *prevChild, *newChild;

    thisNode = list;
    if (INVALID_HANDLE_VALUE == (FindHandle = FindFirstFile(startPath, &FindFileData)))
    {
        return;
    }

    while(FindNextFile(FindHandle, &FindFileData))
    {
        if ( (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && 
             (TYPE_FOLDER == iFileType) )
        {
            if (strcmp(FindFileData.cFileName, "..") && strcmp(FindFileData.cFileName, ".") )
            {
                newChild = getNewNode();
                newChild->iType = TYPE_FOLDER;
                newChild->szName = strdup(FindFileData.cFileName);

                prevChild = thisNode->child;
                thisNode->child = newChild;
                newChild->sibling = prevChild;

                appendPath(startPath, FindFileData.cFileName, subDirPath);
                strcat(subDirPath, "\\*");
                createList(subDirPath, newChild, TYPE_FOLDER);
                createList(subDirPath, newChild, TYPE_LINK);
            }
        }
        else if (TYPE_LINK == iFileType)
        {
            if (strstr(FindFileData.cFileName, ".url"))
            {
                char            sUrl[4096];

                newChild = getNewNode();
                newChild->iType = TYPE_LINK;
                newChild->szName = strdup(FindFileData.cFileName);
                newChild->szName[strlen(newChild->szName)-4] = '\0';

                prevChild = thisNode->child;
                thisNode->child = newChild;
                newChild->sibling = prevChild;

                appendPath(startPath, FindFileData.cFileName, subDirPath);
                GetPrivateProfileString("InternetShortcut", "URL", "", sUrl, sizeof(sUrl), subDirPath);
                newChild->szLink = strdup(sUrl);
            }
        }
    }

    FindClose(FindHandle);

    return;
}

static void saveList(FILE *fpSaveFile, struct URL_NODE *list)
{
    if (list)
    {
        switch(list->iType)
        {
            case TYPE_FOLDER:
                if (list->child)
                {
                    fprintf(fpSaveFile, "<DT><H3 FOLDED>%s</H3>\n", list->szName);
                }
                break;
            case TYPE_LINK:
                fprintf(fpSaveFile, "\t<DT><A HREF=\"%s\">%s</A>\n", list->szLink, list->szName);
                break;
        }
        if (list->child)
        {
            fprintf(fpSaveFile, "<DL><p>\n");
            saveList(fpSaveFile, list->child);
            fprintf(fpSaveFile, "</DL></p>\n");
        }
        saveList(fpSaveFile, list->sibling);
    }
}

static void freeList(struct URL_NODE *list)
{
    if (list)
    {
        freeList(list->child);
        freeList(list->sibling);
        if (list->szName)
        {
            free(list->szName);
        }
        if (list->szLink)
        {
            free(list->szLink);
        }
        free(list);
    }
}
